#!/usr/bin/env sage -python

import sage.all as sage
import sys

def write_sage_cubical_complex(name):
#    complex = getattr(sage.cubical_complexes, name)()

    complex_1 = getattr(sage.cubical_complexes, name)()
    complex_2 = getattr(sage.cubical_complexes, name)()
    complex = complex_1.product(complex_2)
    name = name + '_' + name

    with open(name.lower() + '.pcub', 'wb') as output:
        output.write('{\n' + '\n'.join(map(str, complex.maximal_cells())) + '\n}')

    with open(name.lower() + '.pcub_py', 'wb') as output:
        for f in complex.maximal_cells():
            output.write(','.join(map(str, f)) + '\n')



if __name__ == '__main__':
    write_sage_cubical_complex(sys.argv[1])
