#!/usr/bin/env sage -python

import sage.all as sage
import sys

def main():
    id = 0
    simplices = []

    for line in sys.stdin:
        simplex = map(int, line.split())
        simplices.append(simplex)

    complex = sage.SimplicialComplex(simplices)
    simplices = [x for x in map(list, complex.face_iterator())  if len(x) > 0]
    for x in simplices:
        print "{} {}".format(id, ' '.join(map(str, x)))
        id += 1

if __name__ == '__main__':
    main()
