#!/usr/bin/env sage -python

import sage.all as sage
import cPickle as pickle


def sage_homology(complex):
    return complex.homology()

def convert_complex(sage_complex):
    complex = capdRedHom.SimplicialComplex()
    for face in sage_complex.facets():
        complex.insert(face)

    return complex


def main():
    complex = sage.simplicial_complexes.MatchingComplex(8)

    sage_result = sage_homology(complex)

    print sage_result

    with open('complex.pickle', 'wb') as output:
        pickle.dump([list(f) for f in complex.facets()], output)


if __name__ == '__main__':
    main()
