/// @addtogroup bitSet
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file SComplexFiltrT.hpp
///
/// @author Marian Mrozek
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) Marian Mrozek 2005-2011
//
// This file constitutes a part of the CAPD library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.uj.edu.pl/ for details.





#if !defined(_SCOMPLEX_FILTR_HPP_)
#define _SCOMPLEX_FILTR_HPP_
#include <typeinfo>
#include "SComplexFiltrT.h"
#include <redHom/algorithm/Algorithms.hpp>




// -------------------------------------------------------------------------------------- //

template <typename ComplexT, typename ScalarT, typename IntT>
int SComplexFiltrT<ComplexT, ScalarT, IntT>::maxCycleSize(int q){
  unsigned int maxSize=0;
  for(unsigned int i=0;i<_baseHomologyChains[q].size();++i){
    maxSize=std::max(_baseHomologyChains[q][i].size(),maxSize);
  }
  return (int)maxSize;
}

// -------------------------------------------------------------------------------------- //

template <typename ComplexT, typename ScalarT, typename IntT>
void SComplexFiltrT<ComplexT, ScalarT, IntT>::cycleSizeSpectrum(int q, std::map<int,int>& A_spect){
  for(unsigned int i=0;i<_baseHomologyChains[q].size();++i){
    int size=_baseHomologyChains[q][i].size();
    if(A_spect.find(size)==A_spect.end()) A_spect[size]=1;
    else ++A_spect[size];
  }
}

/************************************************************************************/

#endif // _SCOMPLEX_FILTR_HPP_
/// @}

