/////////////////////////////////////////////////////////////////////////////
/// @file AnyWrapper.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2013-11-29
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2013 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_ANYWRAPPER_H
#define CAPD_FILE_ANYWRAPPER_H

#include <boost/any.hpp>

namespace capd
{
  namespace apiRedHom
  {
    struct AnyWrapper
    {
      AnyWrapper():
        type_id(-1)
      {}

      template<typename T>
      AnyWrapper(const T& obj, size_t type_id):
        _object(obj), type_id(type_id)
      {}

      template <typename T>
      T& get() { return boost::any_cast<T&>(_object); }

      boost::any _object;
      size_t type_id;
    };
  }
}

#endif // CAPD_FILE_ANYWRAPPER_H
