/////////////////////////////////////////////////////////////////////////////
/// @file c_interface
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-01-18
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////


#ifndef CAPD_FILE_CAPDREDHOM_APIREDHOM_C_INTERFACE_HPP
#define CAPD_FILE_CAPDREDHOM_APIREDHOM_C_INTERFACE_HPP

#include "c_interface.h"
#include <boost/shared_ptr.hpp>

namespace capd
{
  namespace apiRedHom
  {

    class Complex;

    template<typename ComplexT>
    void SetComplex(RedHom_ComplexInfo* complexInfo, boost::shared_ptr<ComplexT> complex)
    {
      complexInfo->complexPtr = new boost::shared_ptr<Complex>(complex);
    }

    template<typename ComplexT>
    ComplexT& GetComplex(RedHom_ComplexInfo* complexInfo)
    {
      return dynamic_cast<ComplexT&>(*(*static_cast<boost::shared_ptr<Complex>*>(complexInfo->complexPtr)));
    }

 }
}


#endif // CAPD_FILE_CAPDREDHOM_APIREDHOM_C_INTERFACE_HPP
