/////////////////////////////////////////////////////////////////////////////
/// @file BettiNumbers.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2013-12-20
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2013 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_BETTINUMBERS_H
#define CAPD_FILE_BETTINUMBERS_H


#include <vector>

namespace capd
{
namespace complex
{

  template<typename Complex, typename ScalarT, typename Int=int>
  class BettiNumbers
  {
  public:
    typedef ScalarT Scalar;
    typedef std::vector<Int> result_type;

    explicit BettiNumbers(Complex& complex):
      _complex(complex)
    {}

    result_type operator()();

  private:
    Complex& _complex;
  };

  template<typename Scalar, typename Int=int, typename Complex>
  typename BettiNumbers<Complex, Scalar, Int>::result_type
  ComputeBettiNumbers(Complex& complex)
  {
    return BettiNumbers<Complex, Scalar, Int>(complex)();
  }

}
}

#endif // CAPD_FILE_BETTINUMBERS_H
