/////////////////////////////////////////////////////////////////////////////
/// @file BettiNumbers
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-23
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////


#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_BETTINUMBERS_HPP
#define CAPD_FILE_CAPDREDHOM_COMPLEX_BETTINUMBERS_HPP

#include "BettiNumbers.h"
#include "ComputeHomologyOrchestrator.hpp"

namespace capd
{
  namespace complex
  {

    //BettiNumbers::BettiNumbers() {}

    //BettiNumbers::~BettiNumbers() {}

    template<typename ComplexT, typename ScalarT, typename IntT>
      std::vector<IntT> BettiNumbers<ComplexT, ScalarT, IntT>::operator()()
    {
      ComputeHomologyOrchestrator<ComplexT, ScalarT, IntT> computeHomology(_complex, true, true, true, true);
      return computeHomology();
    }

  }
}


#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_BETTINUMBERS_HPP
