/////////////////////////////////////////////////////////////////////////////
/// @file BettiNumbersViaSmithForm.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-06-12
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2014 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_BETTINUMBERSVIASMITHFORM_H
#define CAPD_FILE_BETTINUMBERSVIASMITHFORM_H

#include <capd/auxil/Logger.h>
#include <vector>

namespace capd
{
namespace complex
{

  template<typename ComplexT, typename ScalarT, typename IntT>
  class BettiNumbersViaSmithForm
  {

  public:
    typedef ComplexT Complex;
    typedef ScalarT Scalar;
    typedef IntT Int;
    typedef std::vector<IntT> result_type;

    BettiNumbersViaSmithForm(const Complex& complex):
      _complex(complex)
    {}

    ~BettiNumbersViaSmithForm()
    {}

    result_type operator()();

  private:
    const Complex& _complex;
    CAPD_CLASS_LOGGER;
  };


}
}

#endif // CAPD_FILE_BETTINUMBERSVIASMITHFORM_H
