/////////////////////////////////////////////////////////////////////////////
/// @file ColoredIteratorFamily
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-02-23
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_COLOREDITERATORFAMILY_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_COLOREDITERATORFAMILY_H

// #include
#include "FilteredIteratorFamily.h"

namespace capd
{
  namespace complex
  {

    namespace _impl
    {
      template<typename Color>
      struct ColorPred
      {
        explicit ColorPred(Color color): _color(color) {}

        template<typename Cell>
        bool operator()(const Cell& cell) const
        {
          return cell.getColor() == _color;
        }
        Color _color;
      };
    }

    template<typename IteratorFamily>
    struct ColoredIteratorFamily:
      FilteredIteratorFamily<IteratorFamily, _impl::ColorPred<typename IteratorFamily::Complex::Color> >
    {
      ColoredIteratorFamily(IteratorFamily iteratorFamily,
                            typename IteratorFamily::Complex::Color color):
        FilteredIteratorFamily<IteratorFamily, _impl::ColorPred<typename IteratorFamily::Complex::Color> >
        (iteratorFamily, _impl::ColorPred<typename IteratorFamily::Complex::Color>(color))
      {}
    };

  }
}

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_COLOREDITERATORFAMILY_H
