#ifndef _CAPD_REDHOM_COMPLEX_CUB_DEFAULT_REDUCE_STRATEGY_TRAITS_CUBSCOMPLEX_HPP_
#define _CAPD_REDHOM_COMPLEX_CUB_DEFAULT_REDUCE_STRATEGY_TRAITS_CUBSCOMPLEX_HPP_

#include <functional>
#include <boost/utility/enable_if.hpp>

namespace capd
{
    namespace complex
    {


template<int DIM>
class DefaultReduceStrategyTraits<CubSComplex<DIM> > {
public:
  typedef CubSComplex<DIM> SComplex;

  template<typename ArgT>
  struct GetReductionPair:  std::unary_function<const ArgT&,
																boost::optional<typename SComplex::template CellProxy<typename SComplex::DynamicCell::Impl*> > > {};
  template<typename ArgT>
  struct GetCoreductionPair:  std::unary_function<const ArgT&,
						  boost::optional<typename SComplex::template CellProxy<typename SComplex::DynamicCell::Impl*> > > {};

  struct Extract {
	 typedef boost::optional<typename SComplex::template CellProxy<typename SComplex::BitCoordCellImpl> >  result_type;
  };

};

    }
  }

#endif // _CAPD_REDHOM_COMPLEX_CUB_DEFAULT_REDUCE_STRATEGY_TRAITS_CUBSCOMPLEX_HPP_
