/////////////////////////////////////////////////////////////////////////////
/// @file EnumerateCellCodes
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-09-13
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_ENUMERATECELLCODES_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_ENUMERATECELLCODES_H

// #include

namespace capd
{
  namespace complex
  {

    template<typename CellCodeT, typename IndexT>
    class EnumerateCellCodes
    {

    public:
      typedef CellCodeT CellCode;
      typedef IndexT Index;

      virtual Index operator[](const CellCode& cellCode) const = 0;
      virtual CellCode operator[](Index index) const = 0;
    };

  }
}

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_ENUMERATECELLCODES_H
