/////////////////////////////////////////////////////////////////////////////
/// @file Homology
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-01-17
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_HOMOLOGY_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_HOMOLOGY_H

// #include
#include <utility>
#include <vector>
#include <string>

namespace capd
{
  namespace complex
  {

    template<typename Complex, typename ScalarT, typename IntT>
    class Homology
    {
    public:
      typedef ScalarT Scalar;
      typedef IntT Int;
      struct Signature
      {
        std::vector<std::pair<Int, std::vector<Int> > > raw;
        std::string str;
      };

      typedef Signature result_type;

      explicit Homology(Complex& complex):
        _complex(complex)
      {}

      result_type operator()();

    private:
      Complex& _complex;
    };


  }
}

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_HOMOLOGY_H
