/////////////////////////////////////////////////////////////////////////////
/// @file Homology
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-01-17
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////


#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_HOMOLOGY_HPP
#define CAPD_FILE_CAPDREDHOM_COMPLEX_HOMOLOGY_HPP

#include <capd/complex/Homology.h>
#include <capd/complex/ComputeHomologyOrchestrator.hpp>
#include <sstream>



namespace capd
{
  namespace complex
  {

    template<typename ComplexT, typename ScalarT, typename IntT>
    typename Homology<ComplexT, ScalarT, IntT>::Signature Homology<ComplexT, ScalarT, IntT>::operator()()
    {
      ComputeHomologyOrchestrator<ComplexT, ScalarT, IntT> computeHomology(_complex, true, true, true, true);
      computeHomology();

      Signature signature;
      std::stringstream str;
      signature.raw = computeHomology.signature().raw();
      str << computeHomology.signature();
      signature.str = str.str();

      return signature;
    }
  }
}


#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_HOMOLOGY_HPP
