/////////////////////////////////////////////////////////////////////////////
/// @file LoggerHelpers
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-02-26
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_LOGGERHELPERS_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_LOGGERHELPERS_H

// #include

#include <iosfwd>
#include <capd/auxil/Logger.h>

namespace capd
{
  namespace complex
  {
    template<typename Value, size_t SIZE>
    struct StaticArray;
  }
}

namespace log4cxx
{
  namespace helpers
  {
    template<typename Value, size_t SIZE>
    std::ostream& operator<<(std::ostream& out, const capd::complex::StaticArray<Value, SIZE>& arr)
    {
      out << "{";
      for (auto x: arr) {
        out << x << ", ";
      }
      out << "}";
      return out;
    }

  }
}

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_LOGGERHELPERS_H
