/////////////////////////////////////////////////////////////////////////////
/// @file ReductionPairProjectionChainModel.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2013-12-30
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2013 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_REDUCTIONPAIRPROJECTIONCHAINMODEL_H
#define CAPD_FILE_REDUCTIONPAIRPROJECTIONCHAINMODEL_H

#include "Chain.h"
#include <boost/foreach.hpp>
#include <boost/assert.hpp>

namespace capd
{
namespace complex
{

  template<typename Complex, typename Scalar, typename ReductionPairs>
  class ReductionPairProjectionChainModel
  {

  public:
    typedef capd::complex::Chain<Complex, Scalar> Chain;
    typedef typename Complex::Dim Dim;

    explicit ReductionPairProjectionChainModel(Dim dim):
      _dim(dim)
    {}

    ~ReductionPairProjectionChainModel()
    {}

    void operator()(Chain& chain)
    {
      BOOST_ASSERT(false); // not done yet !!!!!!!!!
      const bool simplyRemove =  (chain.dim() == _dim);

      BOOST_REVERSE_FOREACH(const ReductionPair& pair, _pairs) {
	if (simplyRemove) {
	  chain.insert(Chain::value_type(pair.coface, Scalar(0)));
	} else {

	}
      }

      chain.compact();
    }

  private:
    const ReductionPairs& _pairs;
    const Complex& complex;
  };


}
}

#endif // CAPD_FILE_REDUCTIONPAIRPROJECTIONCHAINMODEL_H
