/////////////////////////////////////////////////////////////////////////////
/// @file SComplexBase.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-05-28
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2014 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_SCOMPLEXBASE_H
#define CAPD_FILE_SCOMPLEXBASE_H

#include <boost/function.hpp>
#include <boost/lambda/lambda.hpp>
#include <boost/lambda/bind.hpp>

namespace capd
{
namespace complex
{

  class SComplexBase
  {

  public:
    SComplexBase():
      _isClosed(boost::lambda::constant(true))
    {}

    bool isClosed() const { return _isClosed(); }
    void setClosedValidator(const boost::function<bool ()>& v) { _isClosed = v; }

    void setClosed(bool closed)
    {
      setClosedValidator(boost::lambda::constant(closed));
    }

    virtual ~SComplexBase() {}
  private:
    boost::function<bool ()> _isClosed;
  };


}
}

#endif // CAPD_FILE_SCOMPLEXBASE_H
