#ifndef _CAPD_REDHOM_COMPLEX_SCOMPLEX_DEFUALT_TRAITS_HPP
#define _CAPD_REDHOM_COMPLEX_SCOMPLEX_DEFUALT_TRAITS_HPP

#include <cstring>
#include "ColoredObjectsListModel.h"
#include <iosfwd>

namespace capd
{
    namespace complex
    {

      struct SComplexCellCode
      {
        SComplexCellCode(size_t code): _code(code) {}

        bool operator<(const SComplexCellCode& other) const
        {
          return this->_code < other._code;
        }

        bool operator==(const SComplexCellCode& other) const
        {
          return this->_code == other._code;
        }

        size_t code() const { return _code; }

        friend
        std::ostream& operator<<(std::ostream& out, const SComplexCellCode& code)
        {
          out << code.code();
          return out;
        }

      private:
        size_t _code;
      };

      class SComplexDefaultTraits {

      public:

        typedef size_t Size;
        typedef int Dim;
        typedef size_t Id;
        typedef size_t Color;
        typedef SComplexCellCode CellCode;

        template<typename ObjectT>
        class ColoredObjectsModel: public Util::Colors::ColoredObjectsListModel<ObjectT, Color> {

        };

      };

  }
}
#endif // _CAPD_REDHOM_COMPLEX_SCOMPLEX_DEFUALT_TRAITS_HPP
