/////////////////////////////////////////////////////////////////////////////
/// @file SimplicesReader.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-06-11
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2014 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_SIMPLICESREADER_H
#define CAPD_FILE_SIMPLICESREADER_H

#include <capd/auxil/Logger.h>

#include <boost/function.hpp>

#include <vector>
#include <iosfwd>

namespace capd
{
namespace complex
{

  class SimplicesReader
  {

  public:
    typedef std::vector<int> CellCode;

    SimplicesReader(std::istream& input):
      _input(input)
    {}

    ~SimplicesReader()
    {}

    void operator()(const boost::function<void(const CellCode&)>& callback);

  private:
    std::istream& _input;

    CAPD_CLASS_LOGGER;
  };


}
}

#endif // CAPD_FILE_SIMPLICESREADER_H
