
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-02-26
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_STATICARRAY_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_STATICARRAY_H

// #include
#include <vector>
#include <algorithm>
#include <boost/array.hpp>
#include <iosfwd>

namespace capd
{
  namespace complex
  {

    template<typename Value, size_t SIZE>
    struct StaticArray: boost::array<Value, SIZE>
    {
      StaticArray() {}
      StaticArray(const std::vector<Value>& v)
      {
        BOOST_ASSERT(v.size() == SIZE);
        std::copy(v.begin(), v.end(), this->begin());
      }
    };

  }
}

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_STATICARRAY_H
