/////////////////////////////////////////////////////////////////////////////
/// @file Tags
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-03-18
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_TAGS_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_TAGS_H

// #include

namespace capd
{
  namespace complex
  {

    struct CubicalTag {};

    struct RegularCubicalTag {};

    struct DenseCubicalTag: CubicalTag
    {
      static const unsigned ID = 0;
    };

    struct SparseCubicalTag: CubicalTag
    {
      static const unsigned ID = 1;
    };

    struct SimplicialTag
    {
      static const unsigned ID = 2;
    };

    struct GeneralizedTag
    {
      static const unsigned ID = 3;
    };

    struct OldCubicalTag: CubicalTag
    {
      static const unsigned ID = 4;
    };

    struct HasseDiagramTag
    {
      static const unsigned ID = 5;
    };

  }
}

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_TAGS_H
