/************************************************************************/
template <typename T>
class cell
{
public:
    //constructors:
    cell();
    cell( const cell& original);
    cell( std::vector< std::pair<T,T> > coef)
    {          
         for ( unsigned int i = 0 ; i != coef.size() ; ++i )
         {
             this->coef.push_back( std::make_pair(coef[i].first , coef[i].second) );
         }
         this->delet = true;
    }
    
    int dim()
    {
        //counting the number of non degenerated intervals in coef:
        int dim = 0;
        for ( unsigned int i = 0 ; i != this->coef.size() ; ++i )
        {
            if ( this->coef[i].first != this->coef[i].second )
            {
                 ++dim;
            }
        }
        return dim;
    }
    
    
    std::list< cell* >& bd() {return this->bound;};
    std::list< cell* > bd() const {return this->bound;};
    std::list< cell* >& cbd(){return this->coBound;};
    std::list< cell* > cbd()const{return this->coBound;};
    
    typedef typename std::list< cell* >::iterator BdIterator;
    typedef typename std::list< cell* >::iterator CbdIterator;
    
    const BdIterator bdBegin(){return this->bound.begin();};
    const BdIterator bdEnd(){return this->bound.end();};
    const CbdIterator cbdBegin(){return this->coBound.begin();};
    const CbdIterator cbdEnd(){return this->coBound.end();};

    
    unsigned int bdSize();
    unsigned int cbdSize();
    inline void del(){this->delet = true;};
    
    inline void undel(){this->delet = false;};
    
    void undelWithAllBdElem()
    {
         this->undel();
         
         typename cell::BdIterator bd1, bd2;
         for ( bd1 = this->bdBegin() ; bd1 != this->bdEnd() ; ++bd1 )
         {
             (*bd1)->undel();
             for ( bd2 = (*bd1)->bdBegin() ; bd2 != (*bd1)->bdEnd() ; ++bd2 )
             {
                 (*bd2)->undel();
             }
         }
    }
    
    inline bool& deleted(){return this->delet;};

    template < typename A >
    friend std::ostream& operator<<(std::ostream& out, cell<A>& sim)
    {
         out << "[ "  ;
         for ( unsigned int i = 0 ; i != sim.coef.size() ; ++i )
         {
              out << "[" << sim.coef[i].first << "," << sim.coef[i].second << "]";
              if ( i != sim.coef.size()-1 ) out << "x";
         }
         out << " ]";
         return out;       
    };
    
    template < typename A >
    inline friend bool operator == ( const cell<A>& t1, const cell<A>& t2 )
    {
           if ( t1.coef.size() == t2.coef.size() ) 
           {
                for ( unsigned int i = 0 ; i != t1.coef.size() ; ++i )
                {
                    if ( t1.coef[i].first != t2.coef[i].first )
                    {
                         return false;
                    }
                    if ( t1.coef[i].second != t2.coef[i].second )
                    {
                         return false;
                    }                
                }
                return true;
           }           
           return false;
    }
    
    template <typename A>
    friend class cellComplex;
    
    template <typename A>
    friend int computeIncidence( cell<A>* first , cell<A>* second );
    
    template <typename A>
    friend bool checkIfIsASubset( cell<A>* coface , cell<A>* face );
    
    typename std::vector< std::vector<T> > coords(){return this->coef;}
      
protected:
    std::list<cell*> bound;
    std::list<cell*> coBound;
    std::vector< std::pair<T,T> > coef;
    bool delet;    
};//simplex



template <typename A>
bool checkIfIsASubset( cell<A>* coface , cell<A>* face )
{
     if ( coface->coef.size() != face->coef.size() )
     {
          return false;
     }
     for ( unsigned int i = 0 ; i != coface->coef.size() ; ++i )
     {
         if ( !(
             (coface->coef[i].first <= face->coef[i].first)
             &&
             (coface->coef[i].second >= face->coef[i].second)
             )
            )
            {
                return false;
            }
     }
     return true;
}//checkIfIsASubset

template <typename A>
int computeIncidence( cell<A>* coface , cell<A>* face )
{
    if ( checkIfIsASubset(coface, face)==false ){return 0;}
    
    
    
    int sumOfDim = 0;
    unsigned int i = 0; 
    while ( i != coface->coef.size() )
    {
        if ( (coface->coef[i].first != coface->coef[i].second) 
             &&
             ( face->coef[i].first != face->coef[i].second )
           )  
        {             
             ++sumOfDim;
        }
        else
        {            
            std::cerr << "Roznia sie na wymairze : " << i << "\n";
            
            //if coface is non degenerated at this coord:
            if ( coface->coef[i].first != coface->coef[i].second )
            {
                 int minusOneToPowSum = 1;
                 if ( sumOfDim%2 == 1 ){minusOneToPowSum = -1;}
                 //in this case we are sure, that face is degenerated at this cord
                 if ( coface->coef[i].first == face->coef[i].first )
                 {                      
                      return (-1)*minusOneToPowSum;
                 }
                 if ( coface->coef[i].second == face->coef[i].first )
                 {                      
                      return minusOneToPowSum;
                 }
            }                            
        }
        ++i;
    }
    return 0;
}
