template <typename T>
class cellComplex
{
public:
       cellComplex();
       
       cellComplex( std::vector< std::pair<T,T> > cube);
       
       //for division of the cube. Returns true, if the division was succesfull.
       typename std::vector< cell<T>* > divideCube( cell<T>* cube , T x , int cord );              
       
       
       ~cellComplex()
       {
            for ( unsigned int i = 0 ; i != this->elements.size() ; ++i )
            {
                typename std::list< cell<T>* >::iterator it;
                for ( it = this->elements[i].begin() ; it != this->elements[i].end() ; ++it )
                {
                    delete (*it);
                }
            }
       }                     
       
       
        template <class K>
        friend std::ostream& operator<<(std::ostream& out, const cellComplex<K>& cmplx)
        {
             for ( unsigned int i = 0 ; i < cmplx.elements.size() ; ++i )
             {
                 out << "\n dimension : " << i <<"\n";
                 std::cerr << "cmplx.elements[i].size() : " << cmplx.elements[i].size() << "\n";
                 getchar();
                 
                 typename std::set< cell<K>* >::iterator it;
                 
                 for ( it = cmplx.elements[i].begin() ; it != cmplx.elements[i].end() ; ++it )
                 {
                     out << "\n" ;
                     out << "element: "<< (*(*it));
                     out <<"\n";          
                     
                     typename cell<K>::BdIterator bd;
                     for ( bd = (*it)->bdBegin() ; bd != (*it)->bdEnd() ; ++bd )
                     {
                         std::cerr << **bd << " , ";
                     }
                     std::cerr << "\n";
                     std::cerr << "Coboundary of this element : \n";
                     typename cell<K>::CbdIterator cbd;
                     for ( cbd = (*it)->cbdBegin() ; cbd != (*it)->cbdEnd() ; ++cbd )
                     {
                         std::cerr << **cbd << " , ";
                     }
                     std::cerr << "\n";                                          
                 }
                 std::cerr << "Press enter \n";
                 getchar();
             }
             return out;
        }
        
        
        typename std::vector< std::set< cell<T>* > >& elemen(){return this->elements;}
        
        //this procedure returns all the cubes present in the compex. Let me know if this is ok,
        //or you require some more detailed information.
        typename std::vector< cell<T>* > cubesInTheComplex()
        {
            std::vector< cell<T>* > result;
            for ( typename std::list< cell<T>* >::iterator it = this->elements[2].begin() ; it != this->elements[2].end() ; ++it )
            {
                //if ( !(*it)->deleted() )
                {
                     result.push_back( *it );
                }
            }
            return result;
        };
        
        //this procedure is used to divide the cube 'cub' to n*n cubes having the same size
        typename std::vector< cell<T>* > divideTheCubeByGivenFactor( cell<T>* cub , int n );
        
       
private:
       void tie( cell<T>* coface, cell<T>* face );
       void substitute( cell<T>* source , cell<T>* target )
       {
             typename std::list< cell<T>* >::iterator it;
             for ( it = source->bd().begin() ; it != source->bd().end() ; ++it )
             {
                 target->bound.push_back( (*it) );
             }
        
             for ( it = source->cbd().begin() ; it != source->cbd().end() ; ++it )
             {
                 target->coBound.push_back( (*it) );
             }
             target->delet = source->delet;
             
             delete source;
       }
             
protected:
       typename std::vector< std::set< cell<T>* > > elements;
};//simplicalComplex
