/// @addtogroup homologicalAlgebra
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file homologicalAlgebra.h
///
/// @author Marian Mrozek
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2006 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <iterator>
#include <sstream>

#include "capd/matrixAlgorithms/intMatrixAlgorithms.hpp"
#include "capd/repSet/ElementaryCube.h"
#include "capd/repSet/ElementaryCell.h"
#include "capd/repSet/RepSet.h"
using namespace capd::matrixAlgorithms;

#include "capd/homAlgebra/FreeModule.h"
#include "capd/homAlgebra/ChainAux.h"
#include "capd/homAlgebra/SubModule.h"
#include "capd/homAlgebra/QuotientModule.h"
#include "capd/homAlgebra/FreeModuleHomomorphism.h"
#include "capd/homAlgebra/FreeChainComplex.h"
#include "capd/homAlgebra/QuotientGradedModule.h"
#include "capd/redAlg/ReducibleFreeChainComplex.h"
//#include "homologicalAlgebra/ReducibleFreeChainComplex.hpp"











/// @}

