/////////////////////////////////////////////////////////////////////////////
/// @file Helpers
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-04-03
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_HOMAUX_HELPERS_H
#define CAPD_FILE_CAPDREDHOM_HOMAUX_HELPERS_H

// #include
#include <algorithm>
#include <functional>
#include <iterator>
#include <capd/auxil/Logger.h>

namespace capd
{
  namespace homAux
  {

    template<typename T>
    void Shrink(std::vector<T>& v, const T& last=T(0))
    {
      CAPD_DEBUG(v << " " << std::find_if_not(v.rbegin(), v.rend(), std::bind1st(std::equal_to<T>(), last)).base() - v.begin());
      v.erase(std::find_if_not(v.rbegin(), v.rend(), std::bind1st(std::equal_to<T>(), last)).base(), v.end());
    }
  }
}

#endif // CAPD_FILE_CAPDREDHOM_HOMAUX_HELPERS_H
