/////////////////////////////////////////////////////////////////////////////
/// @file AbstractPointCloud.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-06-25
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2014 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_ABSTRACTPOINTCLOUD_H
#define CAPD_FILE_ABSTRACTPOINTCLOUD_H

#include <vector>
#include <cstdlib>

namespace capd
{
  namespace persistence
  {

    class AbstractPointCloud
    {

    public:
      typedef size_t Id;

      AbstractPointCloud()
      {}

      virtual ~AbstractPointCloud()
      {}

      virtual size_t size() const = 0;
      virtual void neighbours(Id idxI, std::vector<Id>& result) const = 0;

      virtual std::vector<Id> neighbours(Id idxI) const
      {
        std::vector<Id> result;
        neighbours(idxI, result);

        return result;
      }

      virtual size_t edges() = 0;
      virtual double distance(Id p1, Id p2) const = 0;

    private:

    };


  }
}

#endif // CAPD_FILE_ABSTRACTPOINTCLOUD_H
