/////////////////////////////////////////////////////////////////////////////
/// @file DegreeLimitedNeighbourhood
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-02
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_PERSISTENCE_DEGREELIMITEDNEIGHBOURHOOD_H
#define CAPD_FILE_CAPDREDHOM_PERSISTENCE_DEGREELIMITEDNEIGHBOURHOOD_H

// #include

namespace capd
{
  namespace persistence
  {

    template<typename PointCloudT>
    class DegreeLimitedNeighbourhood
    {

    public:
      typedef PointCloudT PointCloud;
      typedef typename PointCloud::Distance Distance;
      DegreeLimitedNeighbourhood(PointCloud& cloud, size_t limit, Distance eps = 0):
        _cloud(cloud),
        _limit(limit),
        _eps(eps)
      {}

      void operator()();

    private:
      PointCloud& _cloud;
      const size_t _limit;
      const Distance _eps;
    };


  }
}

#endif // CAPD_FILE_CAPDREDHOM_PERSISTENCE_DEGREELIMITEDNEIGHBOURHOOD_H
