/////////////////////////////////////////////////////////////////////////////
/// @file EuclideanMetric.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-06-25
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2014 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_EUCLIDEANMETRIC_H
#define CAPD_FILE_EUCLIDEANMETRIC_H

#include <capd/vectalg/Vector.h>

namespace capd
{
  namespace persistence
  {

    template<typename ScalarT, size_t DIM>
    class EuclideanMetric
    {

    public:
      typedef ScalarT Scalar;
      typedef double Distance;
      typedef capd::vectalg::Vector<Scalar, DIM> Point;

      Distance operator()(const Point& point1, const Point& point2) const
      {
        return (point1 - point2).euclNorm();
      }

    private:

    };

  }
}

#endif // CAPD_FILE_EUCLIDEANMETRIC_H
