/////////////////////////////////////////////////////////////////////////////
/// @file ImagePersistentHomology
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-09-17
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_PERSISTENCE_IMAGEPERSISTENTHOMOLOGY_H
#define CAPD_FILE_CAPDREDHOM_PERSISTENCE_IMAGEPERSISTENTHOMOLOGY_H

// #include
#include "PersistentHomologyTypes.h"
#include "PersistentSignature.h"
#include <capd/vectalg/Matrix.h>


namespace capd
{
  namespace persistence
  {

    class ImagePersistentHomology
    {

    public:
      typedef capd::vectalg::Matrix<double, 0, 0> Image;

      explicit ImagePersistentHomology(const Image& image):
        _image(image) {}

      virtual ~ImagePersistentHomology() {}

      static bool Enabled();

      const PersistentSignature& operator()();
      const PersistentSignature& signature() const { return _signature; }

    private:
      const Image& _image;
      PersistentSignature _signature;
    };


  }
}

#endif // CAPD_FILE_CAPDREDHOM_PERSISTENCE_IMAGEPERSISTENTHOMOLOGY_H
