/////////////////////////////////////////////////////////////////////////////
/// @file PHATInterface.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-06-24
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2014 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_PHATINTERFACE_H
#define CAPD_FILE_PHATINTERFACE_H

 // there is a bug in any_range.hpp, we need to include it
#include <boost/range/concepts.hpp>
#include <boost/utility.hpp>
#include <boost/range/any_range.hpp>

#include <utility>
#include <vector>

namespace capd
{

  //TODO Now it is used in capd::complex. We need to rename its namespace
  namespace persistence
  {

    class PHATInterface
    {
      static const bool _enabled;

    public:
      static bool enabled() { return _enabled; }

      typedef std::vector<int64_t> Column;
      typedef std::pair<int64_t, Column> FiltrationElement;
      typedef boost::any_range<FiltrationElement, boost::forward_traversal_tag, FiltrationElement&,
                               std::ptrdiff_t> Filtration;
      typedef std::vector<std::pair<int64_t, int64_t> > Pairs;
      typedef std::vector<int64_t> Cycles;

      explicit PHATInterface(){}
      virtual ~PHATInterface() {}

      void operator()(const Filtration& filtration, size_t size, Pairs& pairs, Cycles& cycles);

    };


  }
}

#endif // CAPD_FILE_PHATINTERFACE_H
