/////////////////////////////////////////////////////////////////////////////
/// @file PersistentHomologyTypes
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-09-17
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_PERSISTENCE_PERSISTENTHOMOLOGYTYPES_H
#define CAPD_FILE_CAPDREDHOM_PERSISTENCE_PERSISTENTHOMOLOGYTYPES_H

// #include
#include <vector>
#include <utility>
#include <cstddef>

namespace capd
{
  namespace persistence
  {

      typedef std::vector<std::pair<size_t, size_t> > Pairs;
      typedef std::vector<size_t> Cycles;

      typedef std::pair<double, double> DiagramInterval;
      typedef std::vector<DiagramInterval> Diagram;

  }
}

#endif // CAPD_FILE_CAPDREDHOM_PERSISTENCE_PERSISTENTHOMOLOGYTYPES_H
