/////////////////////////////////////////////////////////////////////////////
/// @file PointCloudTypes.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-06-25
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2014 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_POINTCLOUDTYPES_H
#define CAPD_FILE_POINTCLOUDTYPES_H

#include "PointCloud.h"
#include "EuclideanMetric.h"

namespace capd
{
  namespace persistence
  {

    template<size_t _DIM>
    struct EuclideanPointCloudType
    {
      typedef double ScalarType;
      static const size_t DIM = _DIM;
      typedef EuclideanMetric<ScalarType, DIM> Metric;
      typedef PointCloud<Metric, _DIM> PointCloudType;
      typedef typename PointCloudType::Point Point;
    };

  }
}

#endif // CAPD_FILE_POINTCLOUDTYPES_H
