/////////////////////////////////////////////////////////////////////////////
/// @file SizeLimitedNeighbourhood.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-06-25
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2014 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_SIZELIMITEDNEIGHBOURHOOD_H
#define CAPD_FILE_SIZELIMITEDNEIGHBOURHOOD_H

namespace capd
{
  namespace persistence
  {


    template<typename PointCloudT>
    class SizeLimitedNeighbourhood
    {

    public:
      typedef PointCloudT PointCloud;
      typedef typename PointCloud::Distance Distance;
      SizeLimitedNeighbourhood(PointCloud& cloud, size_t limit, Distance eps = 0):
        _cloud(cloud),
        _limit(limit),
        _eps(eps)
      {}

      void operator()();

    private:
      PointCloud& _cloud;
      const size_t _limit;
      const Distance _eps;
    };


  }
}

#endif // CAPD_FILE_SIZELIMITEDNEIGHBOURHOOD_H
