#if !defined(_HASHER_H_)
#define _HASHER_H_

namespace data_structures {

// Default implementation of a hash function.
// For custom GeneratorCode types, some more reasonable hash function should be created.
template <typename Key>
struct Hasher {
  static int hash(const Key& key) {
    std::cout << "If you don't like linear search complexity, create hash function for " << key << std::endl;
    return 0;
  }
};

// For "int" type, hash is an identity function.
template <>
struct Hasher<int> {
  static int hash(const int& key) {
    return key;
  }
};

// For "pair<int, int>" type, hash is a sum of pair's elements.
template <>
struct Hasher<std::pair<int, int> > {
  static int hash(const std::pair<int, int>& key) {
    return key.first + key.second;
  }
};

}

#endif // _HASHER_H_
