(* ::Package:: *)

BeginPackage["capdRedHom`"]

RedHomCreateSimplicialComplex::usage = "RedHomCreateSimplicialComplex function";
RedHomCreateCubicalComplex::usage = "RedHomCreateCubicalComplex function";
RedHomInsertSimplex::usage="";
RedHomInsertCube::usage="";
RedHomFillWithBoundaries::usage="";
RedHomComplexDim::usage="";
RedHomComplexCardinality::usage="";
RedHomBettiNumbersOverZ::usage="";
RedHomBettiNumbersOverZp::usage="";
RedHomBettiNumbersOverZ2::usage="";

RedHomHomologyOverZ::usage="";
RedHomHomologyOverZ2::usage="";
RedHomHomologyOverZp::usage="";

RedHomCubicalHomologyOverZ::usage="";
RedHomCubicalHomologyOverZ2::usage="";
RedHomCubicalHomologyOverZp::usage="";
RedHomSimplicialHomologyOverZ::usage="";
RedHomSimplicialHomologyOverZ2::usage="";
RedHomSimplicialHomologyOverZp::usage="";

RedHomCubicalBettiNumbersOverZ::usage="";
RedHomCubicalBettiNumbersOverZ2::usage="";
RedHomCubicalBettiNumbersOverZp::usage="";
RedHomSimplicialBettiNumbersOverZ::usage="";
RedHomSimplicialBettiNumbersOverZ2::usage="";
RedHomSimplicialBettiNumbersOverZp::usage="";

RedHomPointCloudPersistentHomology::usage="";

RipsComplex::usage ="Build Rips complex";
PlotSimplicialComplex::usage = "PlotSimplicialComplex function";
ComplexFiltration::usage = "ComplexFiltration function";




Begin["Private`"]

If[ValueQ[$CAPDLibraryPath], AppendTo[$LibraryPath, $CAPDLibraryPath], False];
capdRedHomLibrary="libcapdapiRedHom_mathematica";

LibRedHomGetComplexesCount=LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_GetComplexesCount",{},Integer];
LibRedHomComplexCardinality =LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_ComplexCardinality",{Integer},Integer];
LibRedHomComplexDim = LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_ComplexDim",{Integer},Integer];

LibRedHomCreateSimplicialComplex =LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_CreateSimplicialComplex",{Integer},Void];
LibRedHomCreateCubicalComplex =LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_CreateCubicalComplex",{Integer, {Integer, 1, "Constant"}}, Void];
LibRedHomFillWithBoundaries = LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_FillWithBoundaries",{Integer},Void];
LibRedHomInsertSimplex =LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_InsertSimplex",{Integer,{Integer,1,"Constant"}}, Void];
LibRedHomInsertCube =LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_InsertCube",{Integer,{Integer,2,"Constant"}}, Void];


LibRedHomBettiNumbersOverZ=LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_BettiNumbersOverZ",{Integer},{Integer, 1, "Automatic"}];
LibRedHomBettiNumbersOverZ2=LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_BettiNumbersOverZ2",{Integer},{Integer, 1, "Automatic"}];
LibRedHomBettiNumbersOverZp=LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_BettiNumbersOverZp",{Integer, Integer},{Integer, 1, "Automatic"}];

LibRedHomHomologyOverZ=LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_HomologyOverZ",{Integer}, UTF8String];
LibRedHomHomologyOverZ2=LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_HomologyOverZ2",{Integer}, UTF8String];
LibRedHomHomologyOverZp=LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_HomologyOverZp",{Integer, Integer}, UTF8String];


LibRedHomPointCloudPersistentHomology=LibraryFunctionLoad[capdRedHomLibrary,"RedHom_Mathematica_PointCloudPersistentHomology",{{Real,2,"Constant"}, Integer, Real},{Real, 2, "Automatic"}];



CAPDComplexesQ[e_]:=ManagedLibraryExpressionQ[e,"RedHomCOMPLEXES"];
RedHomComplexId[inst_]:=ManagedLibraryExpressionID[inst,"RedHomCOMPLEXES"];

RedHomCreateSimplicialComplex[]:=Module[{res},res=CreateManagedLibraryExpression["RedHomCOMPLEXES",RedHomSimplicialComplex];
                                     LibRedHomCreateSimplicialComplex[RedHomComplexId[res]];
                                     res];
RedHomCreateSimplicialComplex[simplices_]:=Module[{complex},
                                                  complex = RedHomCreateSimplicialComplex[];
                                                  Map[Function[s, RedHomInsertSimplex[complex,s]],simplices];
                                                  complex
                                                  ];

RedHomCreateEmptyCubicalComplex[size_]:=Module[{res},res=CreateManagedLibraryExpression["RedHomCOMPLEXES",RedHomCubicalComplex];
                                          LibRedHomCreateCubicalComplex[RedHomComplexId[res], size];
                                          res];

RedHomCreateCubicalComplex[cubes_]:=Module[{complex, dims, size},
                                           dims = TensorDimensions[cubes];
                                           Assert[2 == dims[[3]]];
                                           size = Map[
                                                      Function[dim,
                                                               Max[Map[Function[cube, cube[[dim]][[2]] ], cubes]]],
                                                      Range[1, dims[[2]]]];

                                           complex = RedHomCreateEmptyCubicalComplex[size];
                                           Map[Function[c, RedHomInsertCube[complex,c]],cubes];
                                           RedHomFillWithBoundaries[complex];
                                           complex
                                               ];


RedHomComplexDim[c_]:=LibRedHomComplexDim[RedHomComplexId[c]];
RedHomComplexCardinality[c_]:=LibRedHomComplexCardinality[RedHomComplexId[c]];
RedHomInsertSimplex[c_,simplex_]:=LibRedHomInsertSimplex[RedHomComplexId[c],simplex];
RedHomInsertCube[c_,cube_]:=LibRedHomInsertCube[RedHomComplexId[c], cube];
RedHomFillWithBoundaries[c_] := LibRedHomFillWithBoundaries[RedHomComplexId[c]];

RedHomBettiNumbersOverZ[c_]:=LibRedHomBettiNumbersOverZ[RedHomComplexId[c]];
RedHomBettiNumbersOverZ2[c_]:=LibRedHomBettiNumbersOverZ2[RedHomComplexId[c]];
RedHomBettiNumbersOverZp[c_, p_]:=LibRedHomBettiNumbersOverZp[RedHomComplexId[c], p];

RedHomHomologyOverZ[c_]:=LibRedHomHomologyOverZ[RedHomComplexId[c]];
RedHomHomologyOverZ2[c_]:=LibRedHomHomologyOverZ2[RedHomComplexId[c]];
RedHomHomologyOverZp[c_, p_]:=LibRedHomHomologyOverZp[RedHomComplexId[c], p];

RedHomCubicalHomologyOverZ[cubes_]:=RedHomHomologyOverZ[RedHomCreateCubicalComplex[cubes]];
RedHomCubicalHomologyOverZ2[cubes_]:=RedHomHomologyOverZ2[RedHomCreateCubicalComplex[cubes]];
RedHomCubicalHomologyOverZp[cubes_, p_]:=RedHomHomologyOverZp[RedHomCreateCubicalComplex[cubes], p];

RedHomSimplicialHomologyOverZ[simplices_]:=RedHomHomologyOverZ[RedHomCreateSimplicialComplex[simplices]];
RedHomSimplicialHomologyOverZ2[simplices_]:=RedHomHomologyOverZ2[RedHomCreateSimplicialComplex[simplices]];
RedHomSimplicialHomologyOverZp[simplices_, p_]:=RedHomHomologyOverZp[RedHomCreateSimplicialComplex[simplices], p];

RedHomCubicalBettiNumbersOverZ[cubes_]:=RedHomBettiNumbersOverZ[RedHomCreateCubicalComplex[cubes]];
RedHomCubicalBettiNumbersOverZ2[cubes_]:=RedHomBettiNumbersOverZ2[RedHomCreateCubicalComplex[cubes]];
RedHomCubicalBettiNumbersOverZp[cubes_, p_]:=RedHomBettiNumbersOverZp[RedHomCreateCubicalComplex[cubes], p];

RedHomSimplicialBettiNumbersOverZ[simplices_]:=RedHomBettiNumbersOverZ[RedHomCreateSimplicialComplex[simplices]];
RedHomSimplicialBettiNumbersOverZ2[simplices_]:=RedHomBettiNumbersOverZ2[RedHomCreateSimplicialComplex[simplices]];
RedHomSimplicialBettiNumbersOverZp[simplices_, p_]:=RedHomBettiNumbersOverZp[RedHomCreateSimplicialComplex[simplices], p];



RedHomPointCloudPersistentHomology[p_, maxDim_, maxDist_]:=LibRedHomPointCloudPersistentHomology[p,maxDim,maxDist];




RipsComplex[distanceFunction_,numberOfPoints_, maxDist_,maxDim_]:=Module[{points, vertices, CanExtendSimplex, ExtendSimplicesByPoint,ExtendSimplices,simplices },
points=Table[i,{i, numberOfPoints}];
vertices=Subsets[points,{1}];

CanExtendSimplex[simplex_, point_]:=Not[MemberQ[simplex, point]] && Max@@Map[Function[p, distanceFunction[point,p]] ,simplex] < maxDist ;

ExtendSimplicesByPoint[simplices_, point_] :=Map[Function[simplex, Append[simplex, point]],
Select[simplices, Function[s, CanExtendSimplex[s, point]]]];

ExtendSimplices[simplices_, points_] :=Union@@Map[Function[p, ExtendSimplicesByPoint[simplices, p]], points];
simplices = FoldList[ExtendSimplices, vertices, Table[points, {maxDim}]];
simplices
];

PlotSimplicialComplex[simplices_, 0, coordinateFunction_]:= ListPointPlot3D[Map[coordinateFunction, simplices[[1]]]];
PlotSimplicialComplex[simplices_, 1, coordinateFunction_]:= Graphics3D[Line[Map[coordinateFunction,simplices[[2]]]]];
PlotSimplicialComplex[simplices_, dim_, coordinateFunction_] := Graphics3D[Polygon[Map[coordinateFunction,simplices[[dim+1]]]]];

ComplexFiltration[distanceFunction_, complex_, dist_,dim_]:=Module[{SimplexInDistance,FilterSimplices,filtered},
	SimplexInDistance[simplex_]:=And@@Map[Function[p, distanceFunction[p[[1]], p[[2]]] < dist ],Subsets[simplex, {2}]];
	FilterSimplices[simplices_] := Select[simplices, Function[s, SimplexInDistance[s]]];
	filtered=Map[Function[s, FilterSimplices[s]],complex[[1;;dim+1]]];
	filtered
];




End[]

EndPackage[]
