srcDir = $CommandLine[[8]];
buildDir = $CommandLine[[9]];


On[Assert];
$AssertFunction = Function[p, Block[{},
                                    Print[p];
                                    Exit[1]]
                           ];

PrependTo[$Path, StringJoin[srcDir, "/package/capdRedHom"]];

capdRedHom`$CAPDLibraryPath = StringJoin[buildDir, "/.libs"];

Get["capdRedHom.m"];

c = RedHomCreateSimplicialComplex[];
RedHomInsertSimplex[c, {0, 1, 2}];
RedHomInsertSimplex[c, {0, 1, 3}];
RedHomInsertSimplex[c, {0, 4}];
RedHomInsertSimplex[c, {1, 4}];

Assert[14 == RedHomComplexCardinality[c] ];
Assert[{1, 1} == RedHomBettiNumbersOverZ[c]];


c = RedHomCreateSimplicialComplex[{{0, 1, 2}, {0, 1, 3}, {0, 4}, {1,4}}];
Assert[14 == RedHomComplexCardinality[c]];
Assert[{1, 1} == RedHomBettiNumbersOverZ[c]];


kleinBottle = {{3, 4, 6}, {2, 5, 7}, {2, 3, 7}, {3, 4, 7}, {1, 4, 7}, {0, 2, 5}, {2, 4, 6}, {1, 2, 6}, {0, 1, 6}, {1, 3, 5}, {1, 2, 3}, {0, 2, 4}, {1, 5, 7}, {0, 1, 4}, {0, 5, 6}, {3, 5, 6}};

c = RedHomCreateSimplicialComplex[kleinBottle];
x = "  H_0 = Z
  H_1 = Z + Z/2
"
Assert[x == RedHomHomologyOverZ[c]];
Assert[x == RedHomSimplicialHomologyOverZ[kleinBottle]];

c = RedHomCreateSimplicialComplex[kleinBottle];
x = "  H_0 = Z
  H_1 = Z^2
  H_2 = Z
"
  b = RedHomHomologyOverZ2[c];
Print[b]
Assert[x == b];
Assert[x == RedHomSimplicialHomologyOverZ2[kleinBottle]];

c = RedHomCreateSimplicialComplex[kleinBottle];
x = "  H_0 = Z
  H_1 = Z
"

Assert[x == RedHomHomologyOverZp[c, 7]];
Assert[x == RedHomSimplicialHomologyOverZp[kleinBottle,  7]];


c = RedHomCreateSimplicialComplex[kleinBottle];
x = "  H_0 = Z
  H_1 = Z
"
  b = RedHomHomologyOverZp[c, 31];
Print[b];
Assert[x == b];
Assert[x == RedHomSimplicialHomologyOverZp[kleinBottle,  31]];


matchingComplex8={{5, 9, 13, 26}, {5, 8, 14, 26}, {0, 17, 20, 22}, {5, 12, 14, 19}, {4, 8, 14, 27}, {3, 8, 17, 25}, {6, 9, 15, 20}, {0, 16, 19, 24}, {3, 7, 19, 27}, {5, 8, 17, 22}, {2, 9, 15, 27}, {0, 16, 21, 22}, {1, 11, 21, 22}, {2, 7, 22, 27}, {4, 8, 16, 24}, {6, 11, 15, 18}, {4, 11, 14, 21}, {5, 7, 19, 24}, {2, 9, 17, 25}, {1, 11, 19, 24}, {4, 11, 13, 24}, {2, 12, 14, 25}, {6, 10, 14, 20}, {3, 7, 20, 26}, {5, 7, 21, 22}, {4, 12, 13, 23}, {3, 12, 16, 19}, {1, 10, 21, 23}, {3, 11, 13, 26}, {1, 12, 20, 22}, {3, 12, 15, 20}, {2, 12, 15, 23}, {2, 7, 23, 26}, {0, 15, 20, 24}, {6, 9, 16, 19}, {0, 15, 18, 27}, {4, 9, 16, 21}, {0, 14, 20, 26}, {5, 10, 17, 18}, {5, 8, 15, 24}, {6, 8, 14, 25}, {1, 12, 18, 25}, {3, 11, 15, 21}, {6, 7, 20, 22}, {4, 7, 20, 24}, {6, 10, 13, 23}, {1, 10, 18, 27}, {2, 10, 17, 23}, {3, 8, 15, 27}, {4, 12, 16, 18}, {0, 14, 19, 27}, {1, 8, 22, 27}, {3, 12, 13, 25}, {4, 7, 18, 27}, {0, 13, 23, 26}, {4, 9, 13, 27}, {1, 10, 20, 24}, {1, 9, 21, 25}, {4, 9, 17, 20}, {2, 7, 24, 25}, {5, 7, 18, 26}, {2, 11, 15, 24}, {5, 12, 13, 22}, {1, 9, 19, 27}, {3, 11, 17, 19}, {1, 11, 18, 26}, {0, 16, 18, 26}, {6, 8, 15, 23}, {0, 17, 18, 25}, {0, 17, 19, 23}, {5, 9, 15, 21}, {6, 11, 13, 22}, {1, 8, 23, 26}, {0, 13, 22, 27}, {6, 7, 18, 25}, {5, 10, 14, 21}, {5, 10, 13, 24}, {5, 12, 15, 18}, {0, 14, 21, 25}, {3, 8, 16, 26}, {4, 12, 14, 20}, {4, 8, 17, 23}, {6, 10, 16, 18}, {0, 15, 21, 23}, {5, 9, 17, 19}, {2, 11, 17, 22}, {1, 12, 19, 23}, {3, 10, 13, 27}, {1, 8, 24, 25}, {6, 7, 19, 23}, {3, 7, 21, 25}, {3, 10, 17, 20}, {2, 10, 16, 24}, {6, 9, 13, 25}, {4, 7, 21, 23}, {4, 11, 17, 18}, {1, 9, 20, 26}, {6, 11, 14, 19}, {0, 13, 24, 25}, {2, 11, 14, 26}, {3, 10, 16, 21}, {2, 10, 14, 27}, {6, 8, 16, 22}, {2, 9, 16, 26}, {2, 12, 16, 22}};

c = RedHomCreateSimplicialComplex[matchingComplex8];
x = "  H_0 = Z
  H_1 = 0
  H_2 = Z^132
"
Assert[x == RedHomHomologyOverZp[c, 3]];

Print["Cubical 1"];

cubicalCircle={ {{1,2}, {1,1}}, {{1, 2}, {2,2}}, {{1, 1}, {1, 2}}, {{2,2}, {1, 2}}};
c = RedHomCreateCubicalComplex[cubicalCircle];
x = "  H_0 = Z
  H_1 = Z
"
  y=RedHomHomologyOverZ[c];
Print[y];
Assert[x == y];
Print[RedHomCubicalHomologyOverZ[cubicalCircle]];
Assert[x == RedHomCubicalHomologyOverZ[cubicalCircle]];
Assert[x == RedHomCubicalHomologyOverZ2[cubicalCircle]];
Assert[x == RedHomCubicalHomologyOverZp[cubicalCircle, 1021]];

Print["Cubical 2"];
fullCube=AppendTo[cubicalCircle, {{1,2},{1,2}}];
c = RedHomCreateCubicalComplex[ fullCube];
x = "  H_0 = Z
"
Assert[x == RedHomHomologyOverZ[c]];
Assert[x == RedHomCubicalHomologyOverZ[fullCube]];


Print["Cubical 3"];
cubicalCircle={ {{1,2}, {1,1}}, {{1, 2}, {2,2}}, {{1, 1}, {1, 2}}, {{2,2}, {1, 2}},
                {{1,1}, {1,1}}, {{1,1}, {2,2}}, {{2,2}, {1,1}}, {{2,2}, {2,2}}};
product =
  Flatten[Outer[Function[{a, b}, Join[a, b]], cubicalCircle,
    cubicalCircle, 1], 1];

Print[product];
x = "  H_0 = Z
  H_1 = Z^2
  H_2 = Z
"
Assert[x==RedHomCubicalHomologyOverZ[product]];
Assert[x==RedHomCubicalHomologyOverZ2[product]];

Print["Persistence"];
Assert[{{0., \[Infinity]}, {0., \[Infinity]}} == RedHomPointCloudPersistentHomology[{{.1, .2, .3}, {.0, .0, .0}}, 1, .1]];
