/////////////////////////////////////////////////////////////////////////////
/// @file Algorithms
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-22
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#include "Algorithms.h"
#include <capd/apiRedHom/Algorithms.h>

#include "Complex.h"
#include "Convert.h"

#include <boost/python.hpp>
#include <boost/bind.hpp>

namespace b = boost;
namespace bp = boost::python;


using namespace capd;
using namespace capd::apiRedHom::python;


BettiNumbersOverZ::BettiNumbersOverZ(Complex& complex):
  _impl(new apiRedHom::BettiNumbersOverZ(complex.impl()))
{}

boost::python::list BettiNumbersOverZ::operator()()
{
  return ToPython((*_impl)());
}

FundamentalGroup::FundamentalGroup(Complex& complex):
  _impl(new apiRedHom::FundamentalGroup(complex.impl(), 0))
{}

boost::python::list FundamentalGroup::operator()()
{
  return ToPython((*_impl)());
}
