/////////////////////////////////////////////////////////////////////////////
/// @file Algorithms
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-22
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_PROGRAM_ALGORITHMS_H
#define CAPD_FILE_CAPDREDHOM_PROGRAM_ALGORITHMS_H

#include <boost/shared_ptr.hpp>

namespace boost {
  namespace python {
    class list; // GCXML cannot parse boost/python.hpp, so we have to do a trick. We can use this calss only in cpp files.
    class tuple;
  }
}

namespace capd
{
  namespace apiRedHom
  {
    class BettiNumbersOverZ;
    class FundamentalGroup;

    namespace python {
      class Complex;

      struct BettiNumbersOverZ
      {
        explicit BettiNumbersOverZ(Complex& complex);
        boost::python::list operator()();

      private:
        boost::shared_ptr<apiRedHom::BettiNumbersOverZ> _impl;
      };

      struct FundamentalGroup
      {
        explicit FundamentalGroup(Complex& complex);
        boost::python::list operator()();

      private:
        boost::shared_ptr<apiRedHom::FundamentalGroup> _impl;
      };

    }
  }
}


#endif // CAPD_FILE_CAPDREDHOM_PROGRAM_ALGORITHMS_H
