/////////////////////////////////////////////////////////////////////////////
/// @file Complex
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-22
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#include <Complex.h>
#include <capd/apiRedHom/Complex.h>

using namespace capd;
using namespace capd::apiRedHom::python;

Complex::Complex(apiRedHom::Complex* impl):
  _impl(impl)
{
}

Complex::~Complex(){}

apiRedHom::Complex& Complex::impl()
{
  return dynamic_cast<apiRedHom::Complex&>(*_impl);
}

const apiRedHom::Complex& Complex::impl() const
{
  return dynamic_cast<const apiRedHom::Complex&>(*_impl);
}

int Complex::dim() const
{
  return impl().dim();
}

int Complex::cardinality() const
{
  return impl().cardinality();
}
