/////////////////////////////////////////////////////////////////////////////
/// @file Complex
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-22
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_PROGRAM_COMPLEX_H
#define CAPD_FILE_CAPDREDHOM_PROGRAM_COMPLEX_H

#include <boost/shared_ptr.hpp>

namespace capd
{
  namespace apiRedHom
  {

    class Complex;

    namespace python {

      class Complex
      {

      public:
        explicit Complex(apiRedHom::Complex* impl);

        int dim() const;
        int cardinality() const;

        virtual ~Complex(); // make sure the implementation (even empty) is in the c++, so we have there definition of the apiRedHom::Complex object during compile time

        apiRedHom::Complex& impl();
        const apiRedHom::Complex& impl() const;

      protected:
        boost::shared_ptr<apiRedHom::Complex> _impl;
      };

    }

  }
}

#endif // CAPD_FILE_CAPDREDHOM_PROGRAM_COMPLEX_H
