/////////////////////////////////////////////////////////////////////////////
/// @file CubicalComplex.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2013-10-28
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2013 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_CUBICALCOMPLEX_PY_H
#define CAPD_FILE_CUBICALCOMPLEX_PY_H

#include "Complex.h"

namespace boost {
  namespace python {
    class list; // GCXML cannot parse boost/python.hpp, so we have to do a trick. We can use this calss only in cpp files.
    class tuple;
  }
}

namespace capd
{
  namespace apiRedHom
  {

    class CubicalComplex;

    namespace python
    {

      class CubicalComplex: public Complex
      {
      public:
        typedef boost::python::tuple Interval;
        typedef boost::python::list CellCode;

        explicit CubicalComplex(const boost::python::list& size);

        void insert(const CellCode& cube);
        void fillWithBoundaries();

        apiRedHom::CubicalComplex& impl();
        const apiRedHom::CubicalComplex& impl() const;

      private:

      };


    }

  }
}

#endif // CAPD_FILE_CUBICALCOMPLEX_PY_H
