/////////////////////////////////////////////////////////////////////////////
/// @file DistanceMatrixPersistentHomology
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-10-21
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_PROGRAM_DISTANCEMATRIXPERSISTENTHOMOLOGY_H
#define CAPD_FILE_CAPDREDHOM_PROGRAM_DISTANCEMATRIXPERSISTENTHOMOLOGY_H

// #include
#include <boost/shared_ptr.hpp>
#include <vector>

namespace boost {
  namespace python {
    class list; // GCXML cannot parse boost/python.hpp, so we have to do a trick. We can use this calss only in cpp files.
  }
}

namespace capd
{
  namespace apiRedHom
  {
    class DistanceMatrixPersistentHomology;

    namespace python
    {
      class DistanceMatrixPersistentHomology
      {

      public:
        DistanceMatrixPersistentHomology(const boost::python::list& distanceMatrix, size_t dim, size_t degreeLimit);

        virtual ~DistanceMatrixPersistentHomology() {}

        void operator()();
        boost::python::list diagram(int dim=-1) const;
        boost::python::list cycles(int dim=-1) const;
        boost::python::list pairs(int dim=-1) const;

      private:
        const std::vector<std::vector<double> > _distanceMatrix;
        boost::shared_ptr<apiRedHom::DistanceMatrixPersistentHomology> _impl;
      };
    }

  }
}

#endif // CAPD_FILE_CAPDREDHOM_PROGRAM_DISTANCEMATRIXPERSISTENTHOMOLOGY_H
