/////////////////////////////////////////////////////////////////////////////
/// @file ImagePersistentHomology
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-09-18
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#include "ImagePersistentHomology.h"
#include <capd/apiRedHom/Algorithms.h>

#include "Convert.h"

#include <boost/python.hpp>
#include <capd/auxil/Logger.h>


using namespace capd;
using namespace capd::apiRedHom::python;

ImagePersistentHomology::ImagePersistentHomology(const boost::python::list& image):
  _image(FromPython<apiRedHom::ImagePersistentHomology::Image>(image)),
  _impl(new apiRedHom::ImagePersistentHomology(_image))
{
}

boost::python::list ImagePersistentHomology::operator()()
{
  const apiRedHom::ImagePersistentHomology::Diagram& diagram = (*_impl)();
  return ToPython(diagram);
}

boost::python::list ImagePersistentHomology::diagram() const
{
  return ToPython(_impl->diagram());
}

boost::python::list ImagePersistentHomology::diagramInDim(size_t dim) const
{
  return ToPython(_impl->diagram(dim));
}
