/////////////////////////////////////////////////////////////////////////////
/// @file ImagePersistentHomology
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-09-18
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_PROGRAM_IMAGEPERSISTENTHOMOLOGY_H
#define CAPD_FILE_CAPDREDHOM_PROGRAM_IMAGEPERSISTENTHOMOLOGY_H

// #include
#include <boost/shared_ptr.hpp>
#include <vector>

namespace boost {
  namespace python {
    class list; // GCXML cannot parse boost/python.hpp, so we have to do a trick. We can use this calss only in cpp files.
  }
}

namespace capd
{
  namespace apiRedHom
  {

    class ImagePersistentHomology;

    namespace python
    {

      class ImagePersistentHomology
      {

      public:
        ImagePersistentHomology(const boost::python::list& image);

        virtual ~ImagePersistentHomology() {}

        boost::python::list operator()();
        boost::python::list diagram() const;
        boost::python::list diagramInDim(size_t dim) const;

      private:
        const std::vector<std::vector<double> > _image;
        boost::shared_ptr<apiRedHom::ImagePersistentHomology> _impl;
      };

    }
  }
}

#endif // CAPD_FILE_CAPDREDHOM_PROGRAM_IMAGEPERSISTENTHOMOLOGY_H
