/////////////////////////////////////////////////////////////////////////////
/// @file SimplicialComplex
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-22
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#include "SimplicialComplex.h"

#include "capd/apiRedHom/Complex.h"
#include "Convert.h"

#include <boost/python.hpp>
#include <boost/bind.hpp>

using namespace capd;
using namespace capd::apiRedHom::python;
namespace b = boost;
namespace bp = boost::python;


namespace capd
{
  namespace apiRedHom
  {
    namespace python
    {
    }
  }
}

namespace
{
  capd::apiRedHom::SimplicialComplex* CreateSimplicialComplex()
  {
    return new apiRedHom::SimplicialComplex();
  }

}


SimplicialComplex::SimplicialComplex():
  Complex(CreateSimplicialComplex())
{

}

apiRedHom::SimplicialComplex& SimplicialComplex::impl()
{
  return dynamic_cast<apiRedHom::SimplicialComplex&>(this->Complex::impl());
};

const apiRedHom::SimplicialComplex& SimplicialComplex::impl() const
{
  return dynamic_cast<const apiRedHom::SimplicialComplex&>(this->Complex::impl());
};


void SimplicialComplex::insert(const CellCode& cube)
{
  impl().insert(FromPython<apiRedHom::SimplicialComplex::CellCode>(cube));
}
