/////////////////////////////////////////////////////////////////////////////
/// @file SimplicialComplex
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-22
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_PROGRAM_SIMPLICIALCOMPLEX_H
#define CAPD_FILE_CAPDREDHOM_PROGRAM_SIMPLICIALCOMPLEX_H

#include "Complex.h"

namespace boost {
  namespace python {
    class list; // GCXML cannot parse boost/python.hpp, so we have to do a trick. We can use this calss only in cpp files.
    class tuple;
  }
}

namespace capd
{
  namespace apiRedHom
  {

    class SimplicialComplex;

    namespace python
    {

      class SimplicialComplex: public Complex
      {
      public:
        typedef boost::python::list Point;
        typedef boost::python::list CellCode;

        explicit SimplicialComplex();

        void insert(const CellCode& cube);

      protected:
        apiRedHom::SimplicialComplex& impl();
        const apiRedHom::SimplicialComplex& impl() const;
      private:

      };


    }

  }
}

#endif // CAPD_FILE_CAPDREDHOM_PROGRAM_SIMPLICIALCOMPLEX_H
