import os
import sys
sys.path.append( '../../../..' )
import subprocess
import string
import inspect

try:
    from pyplusplus import module_builder
    import pygccxml
except ImportError as ex:
    print ex, "Cannot load modules"
    sys.exit(0) # we do not want to fail build (the generated file always exitsts in repo)

src_dir = sys.argv[1]

capd_cflags = '-I{} '.format(src_dir) + subprocess.check_output([ "/home/me/work/capd/build/default/bin/capd-config" , "--cflags"]).replace('-pthread', '').strip()
python_cflags = subprocess.check_output(["python-config", "--cflags"]).replace('-pthread', '').replace('--param=ssp-buffer-size=4', '').strip()


tmpl_inst = """
#include <vector>
int _EXPOSE_0 = sizeof(std::vector<std::vector<int> >);
"""

files = ['CubicalComplex.h', 'Complex.h', 'SimplicialComplex.h', 'Algorithms.h', 'ImagePersistentHomology.h', 'Logger.h', 'DistanceMatrixPersistentHomology.h']

this_module = module_builder.module_builder_t(
    working_directory=src_dir,
    files = [  module_builder.create_text_fc( tmpl_inst )] + files,
    cflags = capd_cflags + " " + python_cflags)

# this_module.variables().exclude()


for c in this_module.classes( lambda cls: cls.name in ['Complex', 'CubicalComplex', 'SimplicialComplex'] ):
    c.member_functions(name='impl').exclude()


this_module.build_code_creator(module_name="libcapdapiRedHom_py")
this_module.code_creator.add_include('capd/apiRedHom/Complex.h')

#this_module.code_creator.user_defined_directories.append( os.path.abspath( src_dir ) )

this_module.write_module(src_dir + "/PythonApi.cpp")

#for p in this_module.classes( lambda cls: cls.name.startswith( 'pair' ) ):
#    print p
    #p.include()

# this_module.print_declarations()

# le = mb.class_('::capd::lorenz::LorenzEquation')
#vector = mb.class_('::capd::vectalg::Vector<double, 3>')
#mb.print_declarations(vector,le)

# mb.build_code_creator( module_name='hw' )


# #It is common requirement in software world - each file should have license
# mb.code_creator.license = '//Boost Software License( http://boost.org/more/license_info.html )'

# #I don't want absolute includes within code
# mb.code_creator.user_defined_directories.append( os.path.abspath('.') )

# #And finally we can write code to the disk
# mb.write_module( os.path.join( os.path.abspath('.'), 'generated.cpp' ) )
