import cython
from cpython.ref cimport PyObject

# import both numpy and the Cython declarations for numpy
import numpy as np
cimport numpy as np

# declare the interface to the C code
cdef extern void PyCubicalComplex_insertFullCubes(object complex, long* coords, int coordsNum, int coordDim)



@cython.boundscheck(False)
@cython.wraparound(False)
def CubicalComplex_insert_full_cubes_numpy_array(complex, np.ndarray[long, ndim=2, mode="c"] input not None):
    cdef int m, n

    coords_num, coord_dim = input.shape[0], input.shape[1]

    PyCubicalComplex_insertFullCubes(complex, &input[0,0], coords_num, coord_dim)

    return None
