import unittest as ut
from capdRedHom.persistence import *

@ut.skipIf(not BottleneckDistance.enabled(), "Not implemented")
class TestBottleneckDistance(ut.TestCase):

    def test_0(self):
        diagram_a = Diagram()
        diagram_b = Diagram()
        diagram_a.add_interval((1, 2))

        diagram_a()
        diagram_b()

        dist = BottleneckDistance(diagram_a, diagram_b, False)
        self.assertTrue(1 <= dist() <= 1.02)

    def test_1(self):
        diagram_a = Diagram()
        diagram_b = Diagram()
        diagram_a.add_interval((1, 2))
        diagram_b.add_interval((1, 3))

        diagram_a()
        diagram_b()

        dist = BottleneckDistance(diagram_a, diagram_b, False)
        self.assertTrue(1 <= dist() <= 1.02)

    def test_3(self):
        diagram_a = Diagram()
        diagram_b = Diagram()
        diagram_a.add_interval((1, 2))
        diagram_b.add_interval((1, 12))

        diagram_a.add_interval((100, 200))
        diagram_b.add_interval((101, 201))

        diagram_a()
        diagram_b()

        dist = BottleneckDistance(diagram_a, diagram_b, False)()
        self.assertTrue(10 <= dist <= 10.02, dist)

    def test_x(self):
        diagram_a = Diagram()
        diagram_b = Diagram()
        diagram_a.add_interval((1, 1.1))
        diagram_a.add_interval((2, 2.1))
        diagram_a.add_interval((3, 3.2))
        diagram_a.add_interval((0.9, 2.1))
        diagram_a.add_interval((0.9, 3.1))

        diagram_b.add_interval((1, 2))
        diagram_b.add_interval((1.2, 3.2))
        diagram_b.add_interval((2.1, 2.2))

        diagram_a()
        diagram_b()

        dist = BottleneckDistance(diagram_a, diagram_b, False)()
        self.assertTrue(0.3 <= dist <= 0.31)
