/////////////////////////////////////////////////////////////////////////////
/// @file SComplexFactory
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-28
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#include "SComplexFactory.h"


SComplexFactory<SimplexSComplex>::SComplexPtr
SComplexFactory<SimplexSComplex>::Load(const char* filename)
{
    Simplices simplices;
    SimplicesSupplier<Id>::Load(filename, simplices);
    return Create(simplices);
}

SComplexFactory<SimplexSComplex>::SComplexPtr
SComplexFactory<SimplexSComplex>::Create(DebugComplexType type)
{
    Simplices simplices;
    SimplicesSupplier<Id>::Create(type, simplices);
    return Create(simplices);
}

SComplexFactory<SimplexSComplex>::SComplexPtr
SComplexFactory<SimplexSComplex>::Create(Simplices& simplices)
{
    SComplexPtr complex = SComplexPtr(new SComplexType());
    Simplices::iterator it = simplices.begin();
    Simplices::iterator itEnd = simplices.end();
    for ( ; it != itEnd; ++it)
    {
        complex->addSimplex(*it);
    }
    return complex;
}
