/*
 * File:   HomologyTraits.hpp
 * Author: Piotr Brendel
 */

#ifndef HOMOLOGYTRAITS_HPP
#define	HOMOLOGYTRAITS_HPP

#include <capd/complex/CubCellComplex.h>
#include <capd/complex/ComplexSelector.h>


struct BaseHomologyTraits
{
    typedef int                              ScalarType;
    typedef int                                 IntType;
    typedef SComplex<SComplexDefaultTraits>     GeneralSComplexType;
};


template<typename ComplexSelector>
struct HomologyTraits: BaseHomologyTraits
{
  typedef typename ComplexSelector::type SComplexType;
};

template<unsigned _DIM, typename Color>
struct HomologyTraits<capd::complex::ComplexSelector<capd::complex::OldCubicalTag, _DIM, Color> >: BaseHomologyTraits
{
  typedef typename capd::complex::ComplexSelector<capd::complex::OldCubicalTag, _DIM, Color>::type  SComplexType;

  typedef typename SComplexType::BCubCellSet              CubCellSetType;
  typedef CubSetT<typename CubCellSetType::P_EuclSet>       CubSetType;
  typedef CRef<CubSetType>                                CubSetPtrType;

  typedef CRef<CubCellSetType>                            CubCellSetPtrType;
  typedef size_t                                          CubCoordType;
  enum
    {
      DIM = _DIM,
    };
};



#endif	/* HOMOLOGYTRAITS_HPP */
