/////////////////////////////////////////////////////////////////////////////
/// @file helpers.h
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2013-12-10
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2013 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#ifndef CAPD_FILE_HELPERS_H
#define CAPD_FILE_HELPERS_H

#include <capd/config-capdRedHom.h>
#include <capd/apiRedHom/c_interface.h>

#if defined(__cplusplus)
extern "C" {
#endif


#include <src/system.h>
#include <src/objects.h>
#include <src/gasman.h>
#include <src/plist.h>
#include <src/gap.h>
#include <src/lists.h>
#include <src/records.h>
#include <src/precord.h>
#include <src/string.h>

extern Obj Dimension;
extern Obj EvaluateProperty;
extern Obj ArrayValue;

  void ConvertPureCubicalComplex(Obj pureCubicalComplex, RedHom_ComplexInfo* complex);
  void ConvertPureCubicalComplexToSComplex(Obj pureCubicalComplex, RedHom_ComplexInfo* complex);

  int ConvertGAPIntList(Obj list, int** data);
  Obj GAPString(const char* str);
  Obj GAPBettiList(const int* betti, const int dim);
  Obj GAPIntList(const int* array, const unsigned long size);

  Obj Call_1_Wrapper(Obj obj, Obj arg1);
  Obj Call_2_Wrapper(Obj obj, Obj arg1, Obj arg2);



#if defined(__cplusplus)
}
#endif

#endif // CAPD_FILE_HELPERS_H
