/////////////////////////////////////////////////////////////////////////////
/// @file Algorithms_Coreductions
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-23
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#include <capd/apiRedHom/Algorithms.h>
#include <ComplexDescriptors.h>
#include <capd/apiRedHom/Complex.h>
#include <capd/complex/Coreduction.h>

#include <AlgorithmExecutor.h>

using namespace capd;
using namespace capd::apiRedHom;

using namespace capd::apiRedHom;
namespace bl =  boost::lambda;
namespace b = boost;

namespace
{

  struct RunCoreduction
  {
    template<typename TypeDescriptor>
    size_t operator()(TypeDescriptor, AnyWrapper& anyComplex)
    {
      typedef typename TypeDescriptor::type Complex;
      Complex& complex = *anyComplex.get<boost::shared_ptr<Complex> >();

      boost::shared_ptr<typename capd::complex::CoreductionFactory<Complex, int, int>::DefaultAlgorithm> algo =
        capd::complex::CoreductionFactory<Complex, int, int>::createDefault(complex);

      return (*algo)();
    }

  };

}

size_t apiRedHom::Coreduction::operator()()
{
  size_t result = 0;
  RunAlgorithm<capd::complex::Complexes>(complex.anyComplex(), RunCoreduction(), bl::var(result) = bl::_1);
  return result;
}
