/////////////////////////////////////////////////////////////////////////////
/// @file EuclBitSetT_Helper
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-01-17
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_BITSET_EUCLBITSETT_HELPER_H
#define CAPD_FILE_CAPDREDHOM_BITSET_EUCLBITSETT_HELPER_H

#include "capd/bitSet/BitmapT.h"
#include "capd/bitSet/BitSetT.h"
#include "capd/bitSet/EuclBitSetT.hpp"
#include "capd/bitSet/selector.h"

typedef unsigned long int cluster;
typedef BitSetT<BitmapT<cluster> > BitSet;

#define SETUP(dim) \
typedef EuclBitSetT<BitSet,dim> EuclBitSetD##dim; \
template class EuclBitSetT<BitSet,dim>;   \
template std::istream& operator>> <BitSet,dim>(std::istream& in,EuclBitSetD##dim&);  \
template EuclBitSetT<BitSet,dim>& EuclBitSetT<BitSet,dim>::add<HiperSurfSelector>(const HiperSurfSelector&,bool);



#endif // CAPD_FILE_CAPDREDHOM_BITSET_EUCLBITSETT_HELPER_H
