/////////////////////////////////////////////////////////////////////////////
/// @file ComputeHomologySignature_Helper
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-28
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_COMPUTEHOMOLOGYSIGNATURE_HELPER_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_COMPUTEHOMOLOGYSIGNATURE_HELPER_H

#define USE_PRECOMPILED_CAPDREDHOM_COMPLEX_SCOMPLEXTOFREECHAINCOMPLEX_HPP

#include <capd/complex/ComputeHomologySignature.hpp>
#include "Instances.h"

#include <capd/rings/Zp.h>
#include <capd/rings/Z2.h>


namespace capd
{
  namespace complex
  {

    namespace
    {
      template<typename Scalar, typename Int>
      struct CreateNestedType
      {
        typedef boost::mpl::bind<boost::mpl::quote3<ComputeHomologySignature>, boost::mpl::_1, Scalar, Int> type;
      };
    }


#define INSTANCE(ComplexSelectors) \
    static Instances<ComplexSelectors, CreateNestedType<int, int> > i1;  \
    static Instances<ComplexSelectors, CreateNestedType<Zp, int> > i2;   \
    static Instances<ComplexSelectors, CreateNestedType<Z2, int> > i3;

  }
}

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_COMPUTEHOMOLOGYSIGNATURE_HELPER_H
