/////////////////////////////////////////////////////////////////////////////
/// @file Instances
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-02-27
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_INSTANCES_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_INSTANCES_H

// #include
#include <capd/complex/TypesInstantiation.h>

#include <boost/mpl/transform.hpp>
#include <boost/mpl/bind.hpp>
#include <boost/mpl/arg.hpp>
#include <boost/mpl/lambda.hpp>
#include <boost/mpl/quote.hpp>
#include <boost/mpl/protect.hpp>


namespace capd
{
  namespace complex
  {
      template<typename ComplexSelectors, typename CreateNestedType>
      struct Instances
      {
        typedef typename boost::mpl::transform<ComplexSelectors, boost::mpl::quote1<boost::mpl::deref> >::type Complexes;
        typedef typename boost::mpl::transform<Complexes, boost::mpl::protect<typename CreateNestedType::type> >::type NestedTypes;

        TypesInstantiation<NestedTypes, CallInstantiation> instances;
      };
  }
}

#ifndef WRAP
#define WRAP(...) __VA_ARGS__
#endif

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_INSTANCES_H
