/////////////////////////////////////////////////////////////////////////////
/// @file RelativeHomology
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-01-16
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#define USE_PRECOMPILED_CAPDREDHOM_COMPLEX_COMPUTEHOMOLOGYORCHESTRATOR_HPP
#define USE_PRECOMPILED_CAPDREDHOM_COMPLEX_CUBSCOMPLEX_HPP

#include <capd/complex/RelativeHomology.hpp>
#include <capd/complex/CubSComplex.h>
#include <capd/complex/SimplexSComplex.hpp>
#include <capd/complex/SComplex.h>
#include <capd/complex/SComplexDefaultTraits.h>
#include <capd/complex/ComplexSelector.h>
#include "Instances.h"

#include <capd/rings/Zp.h>
#include <capd/rings/Z2.h>
#include <capd/vectalg/Matrix.hpp>


namespace
{
  template<typename Scalar, typename Int>
  struct CreateNestedType
  {
    typedef boost::mpl::bind<boost::mpl::quote3<capd::complex::RelativeHomology>, boost::mpl::_1, Scalar, Int> type;
  };
}

#define INSTANCE(ComplexSelectors) \
    static Instances<ComplexSelectors, CreateNestedType<int, int> > i1;  \
    static Instances<ComplexSelectors, CreateNestedType<Zp, int> > i2;   \
    static Instances<ComplexSelectors, CreateNestedType<Z2, int> > i3;



namespace capd
{
  namespace complex
  {
    INSTANCE(Complexes);
  }
}
