/////////////////////////////////////////////////////////////////////////////
/// @file SComplexToFreeChainComplex_Helper
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-28
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_SCOMPLEXTOFREECHAINCOMPLEX_HELPER_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_SCOMPLEXTOFREECHAINCOMPLEX_HELPER_H


#include <capd/complex/SComplexToFreeChainComplex.hpp>
#include "Instances.h"
#include <boost/mpl/bool.hpp>
#include <capd/rings/Zp.h>
#include <capd/rings/Z2.h>


namespace capd
{
  namespace complex
  {

    namespace
    {
      template<typename Scalar, typename Int, typename Reducible>
      struct CreateNestedType
      {
         typedef boost::mpl::bind<boost::mpl::quote4<SComplexToFreeChainComplex>, boost::mpl::_1, Scalar, Int, Reducible> type;
      };
    }


#define INSTANCE(ComplexSelectors) \
    static Instances<ComplexSelectors, CreateNestedType<int, int, boost::mpl::false_ > > i1; \
    static Instances<ComplexSelectors, CreateNestedType<Zp, int, boost::mpl::false_ > > i2; \
    static Instances<ComplexSelectors, CreateNestedType<Z2, int, boost::mpl::false_ > > i3; \
    static Instances<ComplexSelectors, CreateNestedType<int, int, boost::mpl::true_ > > i4; \
    static Instances<ComplexSelectors, CreateNestedType<Zp, int, boost::mpl::true_ > > i5; \
    static Instances<ComplexSelectors, CreateNestedType<Z2, int, boost::mpl::true_ > > i6;



  }
}

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_SCOMPLEXTOFREECHAINCOMPLEX_HELPER_H
