#include <string>
#include <sstream>
#include <set>

#include <capd/complex/SimplexSComplex.hpp>
#include <capd/complex/SimplexIO.hpp>
#include <capd/complex/SimplexSubdivision.hpp>

using namespace std;


namespace capd
{
    namespace complex
    {

vector<set<int> > parseDat(istream &stream)
{
    vector<set<int> > simplices;

    for (string s; std::getline(stream, s); )
    {
        if (s.size() == 0 || s[0] == '#')
            continue;

        stringstream ss(s);

        set<int> simp;

        for (int v; ss >> v;)
            simp.insert(v);

        simplices.push_back(simp);
    }

    return simplices;
}

void parseDat(istream &stream, SimplexSComplex &comp, int subdivs)
{
    vector<set<int> > simplices = parseDat(stream);

    for (int i = 0; i < subdivs; i++)
        simplices = subdivide3(simplices);

    for (int i = 0; i < simplices.size(); i++)
        comp.addSimplex(simplices[i]);
}

vector<set<int> > parseObj(istream &stream)
{
    using std::string;
    using std::stringstream;

    vector<set<int> > simplices;

    for (string s; getline(stream, s); )
    {
        stringstream ss(s);

        string what;
        ss >> what;

        if (what != "f")
            continue;

        set<int> simp;

        for (string v; ss >> v;)
        {
        	replace(v.begin(), v.end(), '/', ' ');
        	stringstream qq(v);
        	int x;
        	qq >> x;

            simp.insert(x);
        }

        simplices.push_back(simp);
    }

    return simplices;
}

void parseObj(istream &stream, SimplexSComplex &comp, int subdivs)
{
    vector<set<int> > simplices = parseObj(stream);

    for (int i = 0; i < subdivs; i++)
        simplices = subdivide3(simplices);

    for (int i = 0; i < simplices.size(); i++)
        comp.addSimplex(simplices[i]);
}

    }
  }
