#include "capd/complex/SimplexSComplex.hpp"

#include <boost/range/algorithm_ext/is_sorted.hpp>
#include <boost/assert.hpp>

using namespace capd::complex;

SimplexSComplex::Simplex* SimplexSComplex::createSimplexHierarchy(vertex_set &s)
{
  BOOST_ASSERT(s.size() > 0);
  BOOST_ASSERT(boost::is_sorted(s));

    if (s.size() == 1)
    {
        return makeBaseSimplex(s);
    }

    Simplex* rootSimplex = new Simplex(s.begin(), s.end(), nextId++);
    simplexAddedEvent(*rootSimplex);

    // set<int> probably can't be used as a drop-in replacement...
    for (vertex_set::iterator it = s.begin(), end = s.end(); it != end; )
    {
        const int &val = *it;
        vertex_set::iterator new_it = it;
        ++new_it;

        s.erase(it);
        Simplex *subSimplex = addSimplex(s);
        s.insert(it, val);

        rootSimplex->addToBorder(*subSimplex);
        subSimplex->addToCoborder(*rootSimplex, val);
        // {val} = root \ sub

        it = new_it;
    }

    return rootSimplex;
}
