/////////////////////////////////////////////////////////////////////////////
/// @file FreeChainComplex
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-01-16
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#include <capd/homAlgebra/FreeChainComplex.hpp>
#include <capd/rings/Z2.h>
#include <capd/rings/Zp.h>
#include <capd/vectalg/Matrix.hpp>
#include <capd/homAlgebra/FreeModule.h>

#define INSTANCE(Module) \
  template class FreeChainComplex<Module>;


#define WRAP(...) __VA_ARGS__

    INSTANCE(WRAP(FreeModule<int, capd::vectalg::Matrix<int,0,0>, int>));
    INSTANCE(WRAP(FreeModule<int, capd::vectalg::Matrix<Zp,0,0>, int>));
    INSTANCE(WRAP(FreeModule<int, capd::vectalg::Matrix<Z2,0,0>, int>));
