/////////////////////////////////////////////////////////////////////////////
/// @file BuildFiltration
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-06-30
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#include <capd/persistence/BuildFiltration.hpp>
#include <capd/persistence/PointCloudSimplicialCellSComplex.h>
#include <capd/complex/CubCellComplex.h>

namespace capd
{
  namespace persistence
  {

    template class BuildFiltration<PointCloudSimplicialCellSComplex>;

#define INSTANCE(dim) \
    typedef capd::complex::CubCellComplex<capd::complex::FilteredDenseCubMemoryModel<dim> > CubCellComplex___##dim; \
    template class capd::persistence::BuildFiltration<CubCellComplex___##dim>; \

    INSTANCE(0);
    INSTANCE(2);
    INSTANCE(4);
    INSTANCE(5);
    INSTANCE(6);
    INSTANCE(7);
    INSTANCE(8);
    INSTANCE(9);
    INSTANCE(10);


  }

}
