/////////////////////////////////////////////////////////////////////////////
/// @file ComputeHomologyOrchestrator_Helper
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-28
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_COMPUTEHOMOLOGYORCHESTRATOR_HELPER_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_COMPUTEHOMOLOGYORCHESTRATOR_HELPER_H

#define USE_PRECOMPILED_CAPDREDHOM_COMPLEX_COMPUTEHOMOLOGYSIGNATURE_HPP
#include <capd/complex/ComputeHomologyOrchestrator.hpp>
#include <capd/complex/ComplexSelector.h>
#include "../../capd/complex/Instances.h"

#include <capd/multiPrec/MpInt.h>


namespace capd
{
  namespace complex
  {


#ifdef __HAVE_MPFR__
    namespace
    {
      struct CreateNestedType
      {
        typedef boost::mpl::bind<boost::mpl::quote3<ComputeHomologyOrchestrator>, boost::mpl::_1, capd::multiPrec::MpInt, capd::multiPrec::MpInt> type;
      };
    }


#define INSTANCE(ComplexSelectors) \
    static Instances<ComplexSelectors, CreateNestedType > i1;

#endif

#define WRAP(...) __VA_ARGS__


  }
}

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_COMPUTEHOMOLOGYORCHESTRATOR_HELPER_H
