/////////////////////////////////////////////////////////////////////////////
/// @file SComplexToFreeChainComplex_Helper
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2014-07-28
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2014 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_SCOMPLEXTOFREECHAINCOMPLEX_HELPER_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_SCOMPLEXTOFREECHAINCOMPLEX_HELPER_H

#define USE_PRECOMPILED_CAPDREDHOM_COMPLEX_COMPUTEHOMOLOGYSIGNATURE_HPP
#include <capd/complex/SComplexToFreeChainComplex.hpp>
#include <capd/complex/ComplexSelector.h>
#include "../../capd/complex/Instances.h"

#include <capd/multiPrec/MpInt.h>


namespace capd
{
  namespace complex
  {

#ifdef __HAVE_MPFR__

    namespace
    {
      template<typename Scalar, typename Int, typename Reducible>
      struct CreateNestedType
      {
         typedef boost::mpl::bind<boost::mpl::quote4<SComplexToFreeChainComplex>, boost::mpl::_1, Scalar, Int, Reducible> type;
      };
    }


#define INSTANCE(ComplexSelectors) \
    static Instances<ComplexSelectors, CreateNestedType<int, capd::multiPrec::MpInt, boost::mpl::false_ > > i3; \
    static Instances<ComplexSelectors, CreateNestedType<int, capd::multiPrec::MpInt, boost::mpl::true_ > > i4; \


#endif

#define WRAP(...) __VA_ARGS__


  }
}

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_SCOMPLEXTOFREECHAINCOMPLEX_HELPER_H
