/////////////////////////////////////////////////////////////////////////////
/// @file ComplexTest.cpp
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2013-11-28
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2013 by the CAPD::RedHom Group.
//
// This file constitutes a part of the CAPD::RedHom library,
// distributed under the terms of the GNU General Public License.
// Consult  http://redhom.ii.edu.pl/ for details.

#include "capd/apiRedHom/Complex.h"
#include "Fixtures.h"

#define BOOST_TEST_DYN_LINK

#include <boost/test/unit_test.hpp>
#include <boost/lambda/lambda.hpp>
#include <boost/assign.hpp>
#include <boost/foreach.hpp>
#include <boost/range/iterator_range.hpp>

using namespace boost::assign;
using namespace boost::lambda;

using namespace capd::apiRedHom;
using namespace capd::test;

BOOST_AUTO_TEST_SUITE(ComplexSuite)



BOOST_AUTO_TEST_CASE_TEMPLATE(cardinality, Fixture, ComplexFixtures)
{
  Fixture fixture;
  BOOST_CHECK_EQUAL(fixture.cardinality, fixture.complex->cardinality());
  BOOST_CHECK_EQUAL(fixture.dim, fixture.complex->dim());
}

// BOOST_AUTO_TEST_CASE_TEMPLATE(fromRaw, Fixture, CubicalFixtures)
// {
//   Fixture fixture;
//   typedef typename Fixture::ComplexType RawComplex;
//   typedef typename Fixture::APIComplexType APIComplex;
//   RawComplex* rawComplex = new RawComplex(fixture.rawComplex());

//   APIComplex apiComplex(rawComplex);
//   BOOST_CHECK_EQUAL(fixture.cardinality, apiComplex.cardinality());
//   BOOST_CHECK_EQUAL(fixture.dim, apiComplex.dim());
// }


BOOST_AUTO_TEST_SUITE_END()
