/////////////////////////////////////////////////////////////////////////////
/// @file SqueezeIdsFixture
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-01-19
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////

#ifndef CAPD_FILE_CAPDREDHOM_COMPLEX_SQUEEZEIDSFIXTURE_H
#define CAPD_FILE_CAPDREDHOM_COMPLEX_SQUEEZEIDSFIXTURE_H

// #include
#include <boost/mpl/list.hpp>
#include <boost/mpl/joint_view.hpp>
#include <boost/assign.hpp>


namespace capd
{
  namespace test
  {


    struct SqueezeIdsFixture
    {
      std::vector<int> values;
      size_t noOfDistincts;
    };

    struct SqueezeSimpleSetFixture: SqueezeIdsFixture
    {
      SqueezeSimpleSetFixture()
      {
        values = boost::assign::list_of(3)(1)(10)(15)(2).operator std::vector<int>();
        noOfDistincts = 5;
      }
    };

    struct SqueezeSimpleMultiSetFixture: SqueezeIdsFixture
    {
      SqueezeSimpleMultiSetFixture()
      {
        values = boost::assign::list_of(3)(1)(10)(15)(2)(3)(1)(10)(15)(2).operator std::vector<int>();
        noOfDistincts = 5;
      }
    };

    typedef boost::mpl::list<SqueezeSimpleSetFixture, SqueezeSimpleMultiSetFixture> SqueezeIdsFixtures;

  }
}

#endif // CAPD_FILE_CAPDREDHOM_COMPLEX_SQUEEZEIDSFIXTURE_H
