/////////////////////////////////////////////////////////////////////////////
/// @file MergeMapsTest
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-03-30
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////


#include <TestTools.h>
#include <capd/homAux/MergeMaps.h>
#include <capd/auxil/Logger.h>

#define BOOST_TEST_DYN_LINK

#include <boost/test/unit_test.hpp>
#include <boost/test/test_case_template.hpp>
#include <boost/mpl/list.hpp>
#include <boost/lambda/lambda.hpp>
#include <boost/lambda/bind.hpp>
#include <boost/assign.hpp>
#include <boost/foreach.hpp>
#include <boost/iterator/transform_iterator.hpp>
#include <boost/typeof/typeof.hpp>

#include <map>
#include <vector>
#include <algorithm>
#include <utility>
#include <sstream>
#include <functional>

namespace capd
{
  namespace test
  {

  }
}

namespace bl = boost::lambda;
namespace b = boost;
namespace ba = boost::assign;

using namespace capd;
using namespace capd::test;
using namespace capd::homAux;

BOOST_AUTO_TEST_SUITE(MergeMapsTestSuite)

BOOST_AUTO_TEST_CASE( init )
{
  std::map<int, int> m1 = {{10, 0}, {11, 1}, {100, -1}};
  std::map<int, int> m2 = {{10, 100}, {11, 100}, {1000, 100}};
  auto merged = DoMergeMaps(m1, m2, std::plus<int>());
  BOOST_CHECK_EQUAL(100, merged[10]);
  BOOST_CHECK_EQUAL(101, merged[11]);
  BOOST_CHECK_EQUAL(-1, merged[100]);
  BOOST_CHECK_EQUAL(100, merged[1000]);
}


BOOST_AUTO_TEST_SUITE_END()
