/////////////////////////////////////////////////////////////////////////////
/// @file PositionInSequenceTest
///
/// @author Mateusz Juda <mateusz.juda@{ii.uj.edu.pl,gmail.com}>
///
/// @date 2015-04-15
/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000-2015 by the CAPD Group.
//
// This file constitutes a part of the CAPD library (capdRedHom),
// distributed under the terms of the GNU General Public License.
// Consult http://capd.ii.uj.edu.pl and  http://redhom.ii.edu.pl/ for details.
/////////////////////////////////////////////////////////////////////////////


#include <TestTools.h>
#include <capd/homAux/PositionInSequence.h>
#include <capd/auxil/Logger.h>
//#include <../apiRedHom/Fixtures.h>

#define BOOST_TEST_DYN_LINK

#include <boost/test/unit_test.hpp>
#include <boost/test/test_case_template.hpp>
#include <boost/mpl/list.hpp>
#include <boost/lambda/lambda.hpp>
#include <boost/lambda/bind.hpp>
#include <boost/assign.hpp>
#include <boost/foreach.hpp>
#include <boost/iterator/transform_iterator.hpp>
#include <boost/typeof/typeof.hpp>

#include <map>
#include <vector>
#include <algorithm>
#include <utility>
#include <sstream>

namespace capd
{
  namespace test
  {

  }
}

namespace bl = boost::lambda;
namespace b = boost;
namespace ba = boost::assign;

using namespace capd;
using namespace capd::test;
using namespace capd::homAux;

BOOST_AUTO_TEST_SUITE(PositionInSequenceTestSuite)

BOOST_AUTO_TEST_CASE(PositionInSequence_init)
{
  std::vector<int> v = {{4, 1, 0, 3}};
  auto pos = ComputePositionInSequence(v);

  BOOST_CHECK_EQUAL(0, pos[4]);
  BOOST_CHECK_EQUAL(1, pos[1]);
  BOOST_CHECK_EQUAL(2, pos[0]);
  BOOST_CHECK_EQUAL(3, pos[3]);
}

BOOST_AUTO_TEST_SUITE_END()
